unit hiCopyIf;

interface

uses Kol,Share,Debug;

type
  THICopyIf = class(TDebug)
   private
    BeforStr: string; 
    FResult:string;
   public
    _prop_Position: integer;
    _prop_Count: integer;

    _data_Count: THI_Event;
    _data_Position: THI_Event;
    _data_Str: THI_Event;
    _event_onCopy: THI_Event;
    _event_onIsNot: THI_Event;

    property _prop_BeforStr: string write BeforStr;
    procedure _work_doBeforStr(var _Data:TData; Index:word);
    procedure _work_doCopy(var _Data:TData; Index:word);
    procedure _var_Result(var _Data:TData; Index:word);
  end;

implementation

procedure THICopyIf._work_doCopy;
var
  str,bstr:string;
  Pos,Count:integer;
  LengthBstr:integer;
begin
   str := ReadString(_Data,_data_Str,'');
   LengthBstr := Length(BeforStr);
   if str <> '' then begin
      Pos := ReadInteger(_Data,_data_Position,_prop_Position);
      Count := ReadInteger(_Data,_data_Count,_prop_Count);
      if Pos<=0 then begin
         Inc(Count,Pos-1);
         Pos := 1;
      end;
      FResult := '';
      bstr := '';
      if (LengthBStr <> 0) and (Pos - LengthBStr > 0) then 
         bstr := Copy(str, Pos - LengthBStr, LengthBstr);
      if bstr = BeforStr then
         Fresult := Copy(str,Pos,Count);
      if Fresult <> '' then    
         _hi_CreateEvent(_Data,@_event_onCopy,FResult)
      else
         _hi_CreateEvent(_Data,@_event_onIsNot);
   end;
end;

procedure THICopyIf._work_doBeforStr;
begin
   BeforStr := ToString(_Data);
end;

procedure THICopyIf._var_Result;
begin
   dtString(_Data,FResult);
end;

end.
